# Contributing Guidelines
Thank you for your interest in contributing to our project. Whether it's a bug report, new feature, correction, or additional 
documentation, we greatly value feedback and contributions from our community.


## Reporting Bugs/Feature Requests
Please use the GitHub issue tracker to report bugs or suggest features.

When filing an issue, please check [existing open](https://github.com/revdotcom/fstalign/issues), or recently closed, issues to make sure somebody else hasn't already reported the issue. Please try to include as much information as you can. Details like these are incredibly useful:

* A reproducible test case or series of steps
* The environment/deployment of our code being used
* The version of our code being used
* Any modifications you've made relevant to the bug


## Contributing via Pull Requests
This project follows the [Gitflow workflow](https://www.atlassian.com/git/tutorials/comparing-workflows/gitflow-workflow) for contributions. Before sending us a pull request, please ensure that:

1. You are working against the latest source on the *develop* branch.
2. You check existing open, and recently merged, pull requests to make sure someone else hasn't addressed the problem already.
3. You open an issue to discuss any significant work - we would hate for your time to be wasted.

To send us a pull request, please:

1. Fork the repository.
2. Modify the source.
3. Ensure local tests pass.
4. Commit to your fork using clear commit messages.
5. Send us a pull request.
6. Pay attention to any automated CI failures reported in the pull request, and stay involved in the conversation.

GitHub provides additional document on [forking a repository](https://help.github.com/articles/fork-a-repo/) and 
[creating a pull request](https://help.github.com/articles/creating-a-pull-request/).


## Code of Conduct
This project has adopted the [Contributor Covenant Code of Conduct](https://www.contributor-covenant.org/version/1/4/code-of-conduct/).


## Licensing
See the [LICENSE](https://github.com/revdotcom/fstalign/blob/develop/LICENSE) file for our project's licensing. We will ask you to confirm the licensing of your contribution.
